From f2460c2aeca7f2ef51ff9e5325c69f89684efce2 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 7 Jan 2024 11:05:22 +0200
Subject: [PATCH 28/28] Document building sound tags

See RM #64

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/buildings.ruleset         | 3 +++
 data/civ1/buildings.ruleset          | 3 +++
 data/civ2/buildings.ruleset          | 3 +++
 data/civ2civ3/buildings.ruleset      | 3 +++
 data/classic/buildings.ruleset       | 3 +++
 data/goldkeep/buildings.ruleset      | 3 +++
 data/granularity/buildings.ruleset   | 3 +++
 data/multiplayer/buildings.ruleset   | 3 +++
 data/ruledit/comments-3.3.txt        | 3 +++
 data/sandbox/buildings.ruleset       | 3 +++
 data/stub/buildings.ruleset          | 3 +++
 data/webperimental/buildings.ruleset | 3 +++
 12 files changed, 36 insertions(+)

diff --git a/data/alien/buildings.ruleset b/data/alien/buildings.ruleset
index 7d7ccf57f8..52e678ee0c 100644
--- a/data/alien/buildings.ruleset
+++ b/data/alien/buildings.ruleset
@@ -57,6 +57,9 @@ format_version = 40
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ1/buildings.ruleset b/data/civ1/buildings.ruleset
index 50baf53224..a5e662523d 100644
--- a/data/civ1/buildings.ruleset
+++ b/data/civ1/buildings.ruleset
@@ -55,6 +55,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ2/buildings.ruleset b/data/civ2/buildings.ruleset
index 2c92c39697..f93b4aa260 100644
--- a/data/civ2/buildings.ruleset
+++ b/data/civ2/buildings.ruleset
@@ -57,6 +57,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ2civ3/buildings.ruleset b/data/civ2civ3/buildings.ruleset
index d20250ba9c..73a80d72a8 100644
--- a/data/civ2civ3/buildings.ruleset
+++ b/data/civ2civ3/buildings.ruleset
@@ -57,6 +57,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/classic/buildings.ruleset b/data/classic/buildings.ruleset
index 1ebcb48892..266bd1440e 100644
--- a/data/classic/buildings.ruleset
+++ b/data/classic/buildings.ruleset
@@ -57,6 +57,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/goldkeep/buildings.ruleset b/data/goldkeep/buildings.ruleset
index 4d4ed313ec..be4874881c 100644
--- a/data/goldkeep/buildings.ruleset
+++ b/data/goldkeep/buildings.ruleset
@@ -59,6 +59,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/granularity/buildings.ruleset b/data/granularity/buildings.ruleset
index 4e5d2258c7..88cb5114ab 100644
--- a/data/granularity/buildings.ruleset
+++ b/data/granularity/buildings.ruleset
@@ -56,6 +56,9 @@ format_version = 40
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/multiplayer/buildings.ruleset b/data/multiplayer/buildings.ruleset
index d0feb0387d..fbfcb190d5 100644
--- a/data/multiplayer/buildings.ruleset
+++ b/data/multiplayer/buildings.ruleset
@@ -56,6 +56,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 23666c0623..de9b05e631 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -49,6 +49,9 @@ buildings = "\
 ; build_cost    = production shields required to build\n\
 ; upkeep        = monetary upkeep value\n\
 ; sabotage      = percent chance of diplomat sabotage being successful\n\
+; sound         = tag of the sound to play when building finished\n\
+; sound_alt     = alternate sound tag\n\
+; sound_alt2    = second alternative sound tag\n\
 ; flags         = special flag strings\n\
 ;\n\
 ; ** Building flags **\n\
diff --git a/data/sandbox/buildings.ruleset b/data/sandbox/buildings.ruleset
index 858329254d..a6ebfedc49 100644
--- a/data/sandbox/buildings.ruleset
+++ b/data/sandbox/buildings.ruleset
@@ -57,6 +57,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/stub/buildings.ruleset b/data/stub/buildings.ruleset
index 20203377a6..acf63c0a83 100644
--- a/data/stub/buildings.ruleset
+++ b/data/stub/buildings.ruleset
@@ -47,6 +47,9 @@ format_version = 40
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/webperimental/buildings.ruleset b/data/webperimental/buildings.ruleset
index 4aef232e3e..ce1cb17451 100644
--- a/data/webperimental/buildings.ruleset
+++ b/data/webperimental/buildings.ruleset
@@ -57,6 +57,9 @@ building_flags =
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
+; sound_alt2    = second alternative sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
-- 
2.43.0