From 55d31e0b8b2040bfd867db4581e89db3479183d0 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 7 Jan 2024 11:08:16 +0200
Subject: [PATCH 15/15] Document building sound tags

See RM #64

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/buildings.ruleset         | 2 ++
 data/civ1/buildings.ruleset          | 2 ++
 data/civ2/buildings.ruleset          | 2 ++
 data/civ2civ3/buildings.ruleset      | 2 ++
 data/classic/buildings.ruleset       | 2 ++
 data/experimental/buildings.ruleset  | 2 ++
 data/granularity/buildings.ruleset   | 2 ++
 data/multiplayer/buildings.ruleset   | 2 ++
 data/ruledit/comments-3.1.txt        | 2 ++
 data/sandbox/buildings.ruleset       | 2 ++
 data/stub/buildings.ruleset          | 2 ++
 data/webperimental/buildings.ruleset | 2 ++
 12 files changed, 24 insertions(+)

diff --git a/data/alien/buildings.ruleset b/data/alien/buildings.ruleset
index 12b3568cc9..078069179f 100644
--- a/data/alien/buildings.ruleset
+++ b/data/alien/buildings.ruleset
@@ -43,6 +43,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ1/buildings.ruleset b/data/civ1/buildings.ruleset
index 6ed4e0cb3c..c0b7d2822e 100644
--- a/data/civ1/buildings.ruleset
+++ b/data/civ1/buildings.ruleset
@@ -40,6 +40,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ2/buildings.ruleset b/data/civ2/buildings.ruleset
index 5c2cd622f5..56d00ebe0e 100644
--- a/data/civ2/buildings.ruleset
+++ b/data/civ2/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/civ2civ3/buildings.ruleset b/data/civ2civ3/buildings.ruleset
index fd3759857a..f2d3370696 100644
--- a/data/civ2civ3/buildings.ruleset
+++ b/data/civ2civ3/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/classic/buildings.ruleset b/data/classic/buildings.ruleset
index 2ea372372f..0f514004f2 100644
--- a/data/classic/buildings.ruleset
+++ b/data/classic/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/experimental/buildings.ruleset b/data/experimental/buildings.ruleset
index 69deb041ab..0869ea0211 100644
--- a/data/experimental/buildings.ruleset
+++ b/data/experimental/buildings.ruleset
@@ -44,6 +44,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/granularity/buildings.ruleset b/data/granularity/buildings.ruleset
index 57f127ed19..75af2f54bb 100644
--- a/data/granularity/buildings.ruleset
+++ b/data/granularity/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/multiplayer/buildings.ruleset b/data/multiplayer/buildings.ruleset
index 3b8451a62d..5507f079c8 100644
--- a/data/multiplayer/buildings.ruleset
+++ b/data/multiplayer/buildings.ruleset
@@ -41,6 +41,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/ruledit/comments-3.1.txt b/data/ruledit/comments-3.1.txt
index 63b07338ee..04fb008faa 100644
--- a/data/ruledit/comments-3.1.txt
+++ b/data/ruledit/comments-3.1.txt
@@ -47,6 +47,8 @@ buildings = "\
 ; build_cost    = production shields required to build\n\
 ; upkeep        = monetary upkeep value\n\
 ; sabotage      = percent chance of diplomat sabotage being successful\n\
+; sound         = tag of the sound to play when building finished\n\
+; sound_alt     = alternate sound tag\n\
 ; flags         = special flag strings\n\
 ;\n\
 ; ** Building flags **\n\
diff --git a/data/sandbox/buildings.ruleset b/data/sandbox/buildings.ruleset
index 64db7e3e55..398d3df32d 100644
--- a/data/sandbox/buildings.ruleset
+++ b/data/sandbox/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/stub/buildings.ruleset b/data/stub/buildings.ruleset
index ef6f167f4f..c587f8ddd1 100644
--- a/data/stub/buildings.ruleset
+++ b/data/stub/buildings.ruleset
@@ -33,6 +33,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
diff --git a/data/webperimental/buildings.ruleset b/data/webperimental/buildings.ruleset
index 664f0b6679..652e603a52 100644
--- a/data/webperimental/buildings.ruleset
+++ b/data/webperimental/buildings.ruleset
@@ -42,6 +42,8 @@ format_version=20
 ; build_cost	= production shields required to build
 ; upkeep	= monetary upkeep value
 ; sabotage	= percent chance of diplomat sabotage being successful
+; sound         = tag of the sound to play when building finished
+; sound_alt     = alternate sound tag
 ; flags         = special flag strings
 ;
 ; ** Building flags **
-- 
2.43.0