From 1c24e01b557a113d04cab0689479fff0af14fc49 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Mon, 8 Jan 2024 06:13:08 +0200
Subject: [PATCH 32/32] Rename "ui_name_road" as "ui_name_build_road"

See RM #108

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 common/actions.c                   | 4 ++--
 data/alien/actions.ruleset         | 2 +-
 data/civ1/actions.ruleset          | 2 +-
 data/civ2/actions.ruleset          | 2 +-
 data/civ2civ3/actions.ruleset      | 2 +-
 data/classic/actions.ruleset       | 2 +-
 data/goldkeep/actions.ruleset      | 2 +-
 data/multiplayer/actions.ruleset   | 2 +-
 data/sandbox/actions.ruleset       | 2 +-
 data/webperimental/actions.ruleset | 2 +-
 doc/README.actions                 | 4 ++--
 11 files changed, 13 insertions(+), 13 deletions(-)

diff --git a/common/actions.c b/common/actions.c
index 83ffcd7121..e34b9005f8 100644
--- a/common/actions.c
+++ b/common/actions.c
@@ -5828,9 +5828,9 @@ const char *action_ui_name_ruleset_var_name(int act)
   case ACTION_FORTIFY:
     return "ui_name_fortify";
   case ACTION_ROAD:
-    return "ui_name_road";
+    return "ui_name_build_road";
   case ACTION_ROAD2:
-    return "ui_name_road_2";
+    return "ui_name_build_road_2";
   case ACTION_CONVERT:
     return "ui_name_convert_unit";
   case ACTION_BASE:
diff --git a/data/alien/actions.ruleset b/data/alien/actions.ruleset
index d2a8be71e2..cd706107f7 100644
--- a/data/alien/actions.ruleset
+++ b/data/alien/actions.ruleset
@@ -302,7 +302,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/civ1/actions.ruleset b/data/civ1/actions.ruleset
index 6723e02084..6bfde80508 100644
--- a/data/civ1/actions.ruleset
+++ b/data/civ1/actions.ruleset
@@ -287,7 +287,7 @@ ui_name_clean = _("Clean %sPollution%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/civ2/actions.ruleset b/data/civ2/actions.ruleset
index 5a65e1991c..b4e25dadcf 100644
--- a/data/civ2/actions.ruleset
+++ b/data/civ2/actions.ruleset
@@ -340,7 +340,7 @@ ui_name_clean = _("Clean %sPollution%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/civ2civ3/actions.ruleset b/data/civ2civ3/actions.ruleset
index 45e67de091..147a6bf6cc 100644
--- a/data/civ2civ3/actions.ruleset
+++ b/data/civ2civ3/actions.ruleset
@@ -368,7 +368,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/classic/actions.ruleset b/data/classic/actions.ruleset
index e3d67273fb..9134970dc7 100644
--- a/data/classic/actions.ruleset
+++ b/data/classic/actions.ruleset
@@ -359,7 +359,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/goldkeep/actions.ruleset b/data/goldkeep/actions.ruleset
index 13754419c8..59203ae404 100644
--- a/data/goldkeep/actions.ruleset
+++ b/data/goldkeep/actions.ruleset
@@ -359,7 +359,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/multiplayer/actions.ruleset b/data/multiplayer/actions.ruleset
index 0128630d10..95a5694e6d 100644
--- a/data/multiplayer/actions.ruleset
+++ b/data/multiplayer/actions.ruleset
@@ -350,7 +350,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/sandbox/actions.ruleset b/data/sandbox/actions.ruleset
index 986afe0492..03c03a2ca4 100644
--- a/data/sandbox/actions.ruleset
+++ b/data/sandbox/actions.ruleset
@@ -400,7 +400,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/data/webperimental/actions.ruleset b/data/webperimental/actions.ruleset
index bb78b43c99..40a77d289a 100644
--- a/data/webperimental/actions.ruleset
+++ b/data/webperimental/actions.ruleset
@@ -334,7 +334,7 @@ ui_name_clean = _("%sClean%s")
 ui_name_fortify = _("%sFortify%s")
 
 ; /* TRANS: Build _Road (100% chance of success). */
-ui_name_road = _("Build %sRoad%s")
+ui_name_build_road = _("Build %sRoad%s")
 
 ; /* TRANS: _Build Base (100% chance of success). */
 ui_name_build_base = _("%sBuild Base%s")
diff --git a/doc/README.actions b/doc/README.actions
index f0d1c489ab..b9f5f15661 100644
--- a/doc/README.actions
+++ b/doc/README.actions
@@ -1218,7 +1218,7 @@ Actions done by a unit against a tile
    target tile has a city and the city's owner can rebuild it
 
 "Build Road"        - Build road at the target tile.
- * UI name can be set using ui_name_road
+ * UI name can be set using ui_name_build_road
  * actor must be on the same tile as the target.
  * the actor unit has the "Workers" unit type flag (!)
  * the target tile can't have an extra that the target extra must bridge
@@ -1239,7 +1239,7 @@ Actions done by a unit against a tile
    be fulfilled
 
 "Build Road 2"        - Build road at the target tile.
- * UI name can be set using ui_name_road_2
+ * UI name can be set using ui_name_build_road_2
  * See "Build Road" for everything else.
 
 "Build Base"        - Build base at the target tile.
-- 
2.43.0